﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Metrics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PR2
{
    interface Interface
    {
        void Get(); // ввод данных
        int Year(); // подсчёт результата
        void Set(); // вывод результата 
    }

    class BaseClass : Interface // базовый класс, наследуемый от интерфейса
    {
        int year; // год посадки дерева
        int countYear; // определяет количество лет дерева
        public virtual void Set() // метод необходим для ввода года посадки дерева
        {
            Console.Write("Введите год посадки дерева: ");
            year = Convert.ToInt32(Console.ReadLine());
        }
        public int Year() // метод, который подсчитывает сколько лет дереву
        {
            countYear = 2024 - year;
            return countYear;
        }
        public void Get() // метод, который выводит количество лет дерева
        {
            if (year > 2024)
            {
                Console.WriteLine("Вы ввели год, который ещё не наступил.");
            }
            else if (year == 2024)
            {
                Console.WriteLine("Дереву меньше года.");
            }
            else
            {
                Console.WriteLine($"{countYear} лет дереву");
            }
        }
    }

    class MyClass : BaseClass // класс, наследуемый от базового
    {
        int maxHeight; // максимальная высота
        int[] masHeight; // массив, который хранит все введённые высоты
        public override void Set() // переопределённый метод, в котором записываются кол-во сосен и их высоты
        {
            Console.Write("Введите кол-во сосен: ");
            int kol = Convert.ToInt32(Console.ReadLine());
            masHeight = new int[kol];
            Console.WriteLine("Введите высоты деревьев.");
            for (int i = 0; i < kol; i++)
            {
                Console.Write($"Высота для {i+1} сосны: ");
                masHeight[i] = Convert.ToInt32(Console.ReadLine());
            }
        }
        public int MaxHeight() // новый метод, который находит максимальную высоту
        {
            maxHeight = masHeight[0];
            for (int i = 0; i < masHeight.Length; i++)
            {
                if (maxHeight > masHeight[i])
                {
                    maxHeight = masHeight[i];
                }
            }
            return maxHeight;
        }
        new public void Get() // замещенный метод, который выводит масимальную высоту
        {
            Console.WriteLine($"Максимальная высота из всех сосен = {maxHeight}");
        }
    }
}